//allows for printing with features, but uses more memory
#define RPRINTF_FLOAT
#define RPRINTF_COMPLEX

#include "hardware.h"

#include "VR_library.h"		//voice recognition library


// Initialise the hardware
void appInitHardware(void) {
	initHardware();


}
// Initialise the software
TICK_COUNT appInitSoftware(TICK_COUNT loopStart){

	servosDisconnect(&bank1);

	delay_ms(1200);//Axon II bootup time

	rprintf("\n\nAxon Initiated\n");

	VR_Module_init();

	return 0;
}
// This is the main loop
TICK_COUNT appControl(LOOP_COUNT loopCount, TICK_COUNT loopStart) {

	int8_t voice_command=-2;

	//start voice recognition (note: it times out)
	VR_Module_start_recognition(VR_group);//group B
	
	while(voice_command == -2)
		{
		//rprintf("step2");
		
		voice_command = VR_Module_get_result();
		}

	if(voice_command >= 0)
		{
		rprintf("\nvoice command is: ");

		if(VR_group==1 && voice_command==0)
			{
			rprintf(" THAI");
			VR_group=2;
			}
		else if(VR_group==2 && voice_command==0)
			{
			rprintf(" ENGLISH");
			VR_group=1;
			}
		else if((VR_group==1 && voice_command==1) || (VR_group==2 && voice_command==3))
			{
			act_setConnected(&wheel_left, TRUE);
			act_setConnected(&wheel_right, TRUE);
			rprintf(" LEFT");
			act_setSpeed(&wheel_left,127);
			act_setSpeed(&wheel_right,-127);
			act_setSpeed(&elbow,80);
			delay_ms(500);
			}
		else if((VR_group==1 && voice_command==2) || (VR_group==2 && voice_command==4))
			{
			act_setConnected(&wheel_left, TRUE);
			act_setConnected(&wheel_right, TRUE);
			rprintf(" RIGHT");
			act_setSpeed(&wheel_left,-127);
			act_setSpeed(&wheel_right,127);
			act_setSpeed(&elbow,-80);
			delay_ms(500);
			}
		else if((VR_group==1 && voice_command==3) || (VR_group==2 && voice_command==5))
			{
			act_setConnected(&wheel_left, TRUE);
			act_setConnected(&wheel_right, TRUE);
			rprintf(" FORWARD");
			act_setSpeed(&wheel_left,127);
			act_setSpeed(&wheel_right,127);
			act_setSpeed(&elbow,0);
			delay_ms(1500);
			}
		else if(voice_command==4)
			rprintf(" DANCE");
		else if(voice_command==5)
			rprintf(" WAI");
		else if(voice_command==6)
			rprintf(" BOW");
		else if(voice_command==7)
			rprintf(" ARM");
		else if(voice_command==8)
			rprintf(" ATTACK");
		else if(voice_command==9)
			{
			rprintf(" SHUTDOWN");
			servosDisconnect(&bank1);
			}
		else if(voice_command==10)
			{
			rprintf(" POWER_UP");
			servosConnect(&bank1);
			}
		else if(voice_command==11)
			{
			LED_off(&statusLED);
			rprintf(" LED");
			delay_ms(2000);
			LED_on(&statusLED);
			}
		else if((VR_group==1 && voice_command==12) || (VR_group==2 && voice_command==2))
			{
			act_setSpeed(&elbow,80);
			rprintf(" UP");
			}
		else if((VR_group==1 && voice_command==13) || (VR_group==2 && voice_command==1))
			{
			act_setSpeed(&elbow,-80);
			rprintf(" DOWN");
			}
		else if(voice_command==14)
			{
			act_setSpeed(&gripper,-50);
			rprintf(" GRAB");
			}
		else if(voice_command==15)
			{
			act_setSpeed(&gripper,50);
			rprintf(" RELEASE");
			}
		}
	
	//stop further motion
	act_setSpeed(&wheel_left,0);
	act_setSpeed(&wheel_right,0);
	act_setConnected(&wheel_left, FALSE);
	act_setConnected(&wheel_right, FALSE);

	rprintf("\n");
	delay_ms(100);

	return 0;
}

/*
	act_setSpeed(&wheel_left,speed);
	act_setSpeed(&wheel_right,speed);
	act_setSpeed(&gripper,speed);
	act_setSpeed(&elbow,speed);
*/
