/*
		This file has been auto-generated by WebbotLib tools V1.1
				** DO NOT MODIFY BY HAND **
*/
#ifndef _HARDWARE_H_
#define _HARDWARE_H_
#include "xhardware.h"

// ------------------- uart1 -------------------
// Make a transmit buffer for uart1
static unsigned char tx_uart1_Buf[80];
static cBuffer tx_uart1_Buffer = MAKE_BUFFER(tx_uart1_Buf);

// Make a receive buffer for uart1
static unsigned char rx_uart1_Buf[80];
static cBuffer rx_uart1_Buffer = MAKE_BUFFER(rx_uart1_Buf);


// Create hardware UART uart1
HW_UART _uart1 = MAKE_UART_BUFFERED(&rx_uart1_Buffer,&tx_uart1_Buffer,UCSR1A,UCSR1B,UBRR1L,UBRR1H,UDR1,null,BV(U2X1),D2,D3,&uart1GetByte,&uart1SendByte);

// Create a routine to write bytes to uart1
// You can set rprintf to use it by calling rprintfInit(&uart1SendByte)
MAKE_WRITER(uart1SendByte){
	return uartSendByte(uart1,byte);
}

// Create a routine to read a byte from uart1
// Returns -1 if there was no data
MAKE_READER( uart1GetByte){
	return uartGetByte(uart1);
}

#ifndef USART1_TX_vect
# error Uart1 Tx complete vector undefined
#else
ISR(USART1_TX_vect){
	uartTransmitService(uart1);
}
#endif

#ifndef USART1_RX_vect
# error Uart1 Rx complete vector undefined
#else
ISR(USART1_RX_vect){
	uartReceiveService(uart1);
}
#endif

// ------------------- Voice_Recognition -------------------
// Make a transmit buffer for Voice_Recognition
static unsigned char tx_Voice_Recognition_Buf[20];
static cBuffer tx_Voice_Recognition_Buffer = MAKE_BUFFER(tx_Voice_Recognition_Buf);

// Make a receive buffer for Voice_Recognition
static unsigned char rx_Voice_Recognition_Buf[80];
static cBuffer rx_Voice_Recognition_Buffer = MAKE_BUFFER(rx_Voice_Recognition_Buf);


// Create hardware UART Voice_Recognition
HW_UART _Voice_Recognition = MAKE_UART_BUFFERED(&rx_Voice_Recognition_Buffer,&tx_Voice_Recognition_Buffer,UCSR2A,UCSR2B,UBRR2L,UBRR2H,UDR2,null,BV(U2X2),H0,H1,&Voice_RecognitionGetByte,&Voice_RecognitionSendByte);

// Create a routine to write bytes to Voice_Recognition
// You can set rprintf to use it by calling rprintfInit(&Voice_RecognitionSendByte)
MAKE_WRITER(Voice_RecognitionSendByte){
	return uartSendByte(Voice_Recognition,byte);
}

// Create a routine to read a byte from Voice_Recognition
// Returns -1 if there was no data
MAKE_READER( Voice_RecognitionGetByte){
	return uartGetByte(Voice_Recognition);
}

#ifndef USART2_TX_vect
# error Uart2 Tx complete vector undefined
#else
ISR(USART2_TX_vect){
	uartTransmitService(Voice_Recognition);
}
#endif

#ifndef USART2_RX_vect
# error Uart2 Rx complete vector undefined
#else
ISR(USART2_RX_vect){
	uartReceiveService(Voice_Recognition);
}
#endif

// ----------- Define the ADC channels ----------
const uint8_t NUM_ADC_CHANNELS = 16;
const uint16_t PROGMEM AVcc_MV = 5000;

// ----------- My devices -----------------------
SWITCH button = MAKE_SWITCH(D5);
SEGLED led_display = MAKE_SEGLED(C3,C2,C0,D6,D7,C4,C5,null,false);
static SEGLED_LIST marquee_list[] = {
	&led_display
};
MARQUEE marquee = MAKE_MARQUEE(marquee_list,500000,2000000,&marquee_put_char);
// Create a Writer to write to marquee
MAKE_WRITER(marquee_put_char){
	return marqueeSendByte(&marquee,byte);
}
SERVO wheel_left = MAKE_SERVO(false,B5,1500,500);
SERVO wheel_right = MAKE_SERVO(true,B7,1330,500);
SERVO gripper = MAKE_SERVO(false,E3,1500,500);
SERVO elbow = MAKE_SERVO(false,E5,1500,500);
static SERVO_LIST bank1_list[] = {
	&wheel_left,
	&wheel_right,
	&gripper,
	&elbow
};
SERVO_DRIVER bank1 = MAKE_SERVO_DRIVER(bank1_list);

// ----------- Initialise built in devices ------
void sysInitHardware(void){
	SWITCH_init(&button);
	setErrorLog(&uart1SendByte);
	rprintfInit(&uart1SendByte);
	uartInit(uart1,230400);
	segled_init(&led_display);
}

// ----------- Initialise my added devices ------
void initHardware(void){
	uartInit(Voice_Recognition,9600);
	servoPWMInit(&bank1);
}
// ----------- Register the statusLED -----------
void registerLED(void){
	statusLEDregister(C1,false);
}

// ----------- Ports are configured on the fly --
void configure_ports(void){
}

#endif
